﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using System.Threading;
using SlimDX;
using SlimDX.DirectInput;
using FDK;

namespace StrokeStyleT
{
	class C選曲ステージ : CStageBase
	{
		public C選曲ステージ()
		{
			this.eStageID = EステージID.選曲;
			this.ePhaseID = EフェーズID.通常;
		}
		public void t選択曲を最初の曲にリセットする()
		{
			// Global.SongList が再構築された後に呼び出されることを想定している。
			// 本ステージが活性化してるか否かに関係無く呼び出されるので注意。

			this.list現在の曲リスト = Global.Song.list曲リスト;
			this.stackBOXの曲番号 = new Stack<int>();
			this.n現在の選択曲番号 = 0;	// ツリールートにおける選択曲の Song番号をstackに格納。
			this.n現在の中心曲番号 = 0;
			this.nカーソルY位置0to2 = 1;
		}

		public override void On活性化()
		{
			if( this.b活性化してる )
				return;

			this.n目標のスクロールカウンタ = 0;
			this.n現在のスクロールカウンタ = 0;
			this.b曲決定 = false;
			this.mスクロールアニメ用一定間隔処理 = new C一定間隔処理();

			if( this.list現在の曲リスト == null )			// 曲リストや選択曲、中心曲などは、t選択曲を最初の曲にリセットする() を
				this.t選択曲を最初の曲にリセットする();		// 呼び出さない限り、ステージが変わっても維持され続ける。

			this.sdカーソル移動音 = Global.SoundDevice.tサウンドを作成する( Global.Theme.tファイルパス( @"ScreenSelect cursor move.wav" ) );
			this.sd曲決定音 = Global.SoundDevice.tサウンドを作成する( Global.Theme.tファイルパス( @"ScreenSelect decide.wav" ) );
			this.ds背景動画 = Global.t失敗してもスキップ可能なDirectShowを生成する( Global.Theme.tファイルパス( @"ScreenSelect BGV.mp4" ), Global.App.Window.Handle );

			base.On活性化();
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( ref this.mスクロールアニメ用一定間隔処理 );
			C共通.tDisposeする( ref this.sdカーソル移動音 );
			C共通.tDisposeする( ref this.sd曲決定音 );
			C共通.tDisposeする( ref this.ds背景動画 );

			base.On非活性化();
		}
		public override void OnManagedリソースの作成()
		{
			if( this.b活性化してない )
				return;


			// サムネイルテクスチャを復元。

			int nKeys = this.dicThumbnail.Count;
			string[] keys = new string[ nKeys ];
			this.dicThumbnail.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
				this.dicThumbnail[ key ] = this.tサムネイルテクスチャを作成する( Path.GetDirectoryName( key ) );


			// プロパティテクスチャを復元。

			nKeys = this.dicProperty.Count;
			keys = new string[ nKeys ];
			this.dicProperty.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
				this.dicProperty[ key ] = this.tプロパティテクスチャを作成する( key );


			// その他を復元。

			this.txブランク画像 = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect blank image.png" ) );
			this.txSongNotFound = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect song not found.png" ) );
			this.txカーソル = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect cursor.png" ) );
			if( this.ds背景動画 != null )
			{
				this.tx背景動画 = Global.tテクスチャを生成する( this.ds背景動画.n幅px, this.ds背景動画.n高さpx );

				if( this.tx背景動画 != null )
				{
					this.tx背景動画.vc拡大縮小倍率 = new Vector3(
						( (float) Global.Theme.LogicalDisplaySize.Width / (float) this.ds背景動画.n幅px ),
						( (float) Global.Theme.LogicalDisplaySize.Height / (float) this.ds背景動画.n高さpx ),
						1.0f );
				}
			}
			else
				this.tx背景動画 = null;

			base.OnManagedリソースの作成();
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;


			// サムネイルテクスチャを解放。

			int nKeys = this.dicThumbnail.Count;
			string[] keys = new string[ nKeys ];
			this.dicThumbnail.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
			{
				C共通.tDisposeする( this.dicThumbnail[ key ] );
				this.dicThumbnail[ key ] = null;
			}


			// プロパティテクスチャを解放。

			nKeys = this.dicProperty.Count;
			keys = new string[ nKeys ];
			this.dicProperty.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
			{
				C共通.tDisposeする( this.dicProperty[ key ] );
				this.dicProperty[ key ] = null;
			}


			// その他を解放。

			C共通.tDisposeする( ref this.txブランク画像 );
			C共通.tDisposeする( ref this.txSongNotFound );
			C共通.tDisposeする( ref this.txカーソル );
			C共通.tDisposeする( ref this.tx背景動画 );

			base.OnManagedリソースの解放();
		}
		public enum E進行の戻り値 : int { 継続, 曲決定, 終了 }
		public override int On進行()
		{
			if( this.b活性化してない )
				return (int) E進行の戻り値.継続;

			#region [ 初めての進行処理。]
			//-----------------
			if( this.b初めての進行 )
			{
				if( this.ds背景動画 != null )
				{
					this.ds背景動画.bループ再生 = true;
					this.ds背景動画.t再生開始();
				}

				this.b初めての進行 = false;
			}
			//-----------------
			#endregion


			// 進行。

			#region [ スクロールアニメの進行と曲番号マップの更新。]
			//-----------------
			if( this.list現在の曲リスト.Count > 0 )
			{
				// スクロールを進行。

				this.mスクロールアニメ用一定間隔処理.t進行( 5, () => {

					int n加速度 = 1;
					int n残距離 = Math.Abs( (int) ( this.n目標のスクロールカウンタ - this.n現在のスクロールカウンタ ) );

					#region [ 残距離が遠いほどスクロールを速くする（＝n加速度を多くする）。]
					//-----------------
					if( n残距離 <= 100 )
					{
						n加速度 = 4;
					}
					else if( n残距離 <= 300 )
					{
						n加速度 = 8;
					}
					else if( n残距離 <= 500 )
					{
						n加速度 = 12;
					}
					else
					{
						n加速度 = 16;
					}
					//-----------------
					#endregion

					#region [ 加速度を加算し、現在のスクロールカウンタを目標のスクロールカウンタまで近づける。 ]
					//-----------------
					if( this.n現在のスクロールカウンタ < this.n目標のスクロールカウンタ )		// (A) 正の方向に未達の場合：
					{
						this.n現在のスクロールカウンタ += n加速度;								// カウンタを正方向に移動する。

						if( this.n現在のスクロールカウンタ > this.n目標のスクロールカウンタ )
							this.n現在のスクロールカウンタ = this.n目標のスクロールカウンタ;	// 到着！スクロール停止！
					}
					else if( this.n現在のスクロールカウンタ > this.n目標のスクロールカウンタ )	// (B) 負の方向に未達の場合：
					{
						this.n現在のスクロールカウンタ -= n加速度;								// カウンタを負方向に移動する。

						if( this.n現在のスクロールカウンタ < this.n目標のスクロールカウンタ )	// 到着！スクロール停止！
							this.n現在のスクロールカウンタ = this.n目標のスクロールカウンタ;
					}
					//-----------------
					#endregion

					if( this.n現在のスクロールカウンタ >= 100 )		// １行＝100カウント。
					{
						#region [ 曲マトリックスを右から左へ１列シフトする。]
						//-----------------
						if( this.sdカーソル移動音 != null )
							this.sdカーソル移動音.tサウンドを先頭から再生する();

						this.n現在の中心曲番号 = this.t中心曲から指定された相対数だけ離れた曲番号を返す( -3 );
						this.n現在の選択曲番号 = ( ( this.n現在の中心曲番号 + ( this.nカーソルY位置0to2 - 1 ) ) + this.list現在の曲リスト.Count ) % this.list現在の曲リスト.Count;

						this.n現在のスクロールカウンタ -= 100;
						this.n目標のスクロールカウンタ -= 100;

						//if( this.n目標のスクロールカウンタ == 0 )
						//	CDTXMania.stage選曲.t選択曲変更通知();		// スクロール完了＝選択曲変更！

						//-----------------
						#endregion
					}
					else if( this.n現在のスクロールカウンタ <= -100 )
					{
						#region [ 曲マトリックスを左から右へ１列シフトする。]
						//-----------------
						if( this.sdカーソル移動音 != null )
							this.sdカーソル移動音.tサウンドを先頭から再生する();

						this.n現在の中心曲番号 = this.t中心曲から指定された相対数だけ離れた曲番号を返す( +3 );
						this.n現在の選択曲番号 = ( ( this.n現在の中心曲番号 + ( this.nカーソルY位置0to2 - 1 ) ) + this.list現在の曲リスト.Count ) % this.list現在の曲リスト.Count;

						this.n現在のスクロールカウンタ += 100;
						this.n目標のスクロールカウンタ += 100;

						//if( this.n目標のスクロールカウンタ == 0 )
						//	CDTXMania.stage選曲.t選択曲変更通知();		// スクロール完了＝選択曲変更！

						//-----------------
						#endregion
					}
				} );
			}

			// 毎回、最新の情報で更新。

			this.t現在の中心曲を起点として曲番号マップを更新する();
			//-----------------
			#endregion

			#region [ 曲が決定されている場合、終了処理を行う。]
			//-----------------
			if( this.b曲決定 )
			{
				// 決定曲を Global.Song に登録する。

				Global.Song.r現在演奏中の曲 = Global.Song.list曲リスト[ this.n現在の選択曲番号 ];


				// こちらは解放。

				C共通.tDisposeする( ref Global.Song.r現在演奏中の曲のスコア );

				return (int) E進行の戻り値.曲決定;
			}
			//-----------------
			#endregion


			// 入力。

			if( Global.Input.Input管理.hWnd == Global.App.Window.Handle )	// ダイアログ等がInput管理を使用している場合は何もしない。
			{
				#region [ ESC → 終了 ]
				//-----------------
				if( Global.Input.Input管理.Keyboard.bキーが押された( Key.Escape ) )
					return (int) E進行の戻り値.終了;
				//-----------------
				#endregion

				// 以下のキーは、曲決定後には無効。

				if( !this.b曲決定 )
				{
					#region [ F1 → ユーザ別設定ウィンドウ起動 ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F1 ) )
					{
						// ユーザ別設定ウィンドウの表示。

						Global.tダイアログ表示準備();

						var dialog = new Cユーザ別設定ウィンドウ();
						dialog.Owner = Global.App.Window;
						Global.Input.Input管理.Dispose();	// メインフォームでのInput管理をいったん終了。

						// モーダルモードで起動する。閉じるまで処理が帰ってこない。が、Idleイベントは起きるためメインループは並行して進行するので注意する。
						// Input管理 はこの中で新しく作られ、設定ウィンドウ終了後に破棄される。
						dialog.tメイン処理();

						Global.App.Window.Select();
						Global.Input.Input管理 = new CInput管理( Global.App.Window.Handle );	// メインフォームでのInput管理を再開。

						Global.tダイアログ表示後始末();
					}
					//-----------------
					#endregion
					#region [ F2 → ユーザ別曲管理ウィンドウ起動 ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F2 ) )
					{
						// ユーザ別曲管理ウィンドウの表示。
						
						Global.tダイアログ表示準備();

						var dialog = new Cユーザ別曲管理ウィンドウ();
						dialog.Owner = Global.App.Window;
						Global.Input.Input管理.Dispose();	// メインフォームでのInput管理をいったん終了。

						// モーダルモードで起動する。閉じるまで処理が帰ってこない。が、Idleイベントは起きるためメインループは並行して進行するので注意する。
						// Input管理 はこの中で新しく作られ、設定ウィンドウ終了後に破棄される。
						dialog.tメイン処理();

						Global.App.Window.Select();
						Global.Input.Input管理 = new CInput管理( Global.App.Window.Handle );	// メインフォームでのInput管理を再開。

						Global.tダイアログ表示後始末();


						// 曲リストをリセット。

						if( dialog.dialogResult != DialogResult.Cancel && Global.Song.list曲リスト.Count > 0 )
							this.t選択曲を最初の曲にリセットする();
					}
					//-----------------
					#endregion
					#region [ F3 → 入力割り当てウィンドウ起動 ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F3 ) )
					{
						// 入力割り当てウィンドウの表示。

						Global.tダイアログ表示準備();

						var dialog = new C入力割当ウィンドウ();
						dialog.Owner = Global.App.Window;
						Global.Input.Input管理.Dispose();	// メインフォームでのInput管理をいったん終了。

						// モーダルモードで起動する。閉じるまで処理が帰ってこない。が、Idleイベントは起きるためメインループは並行して進行するので注意する。
						// Input管理 はこの中で新しく作られ、設定ウィンドウ終了後に破棄される。
						dialog.tメイン処理();

						Global.App.Window.Select();
						Global.Input.Input管理 = new CInput管理( Global.App.Window.Handle );	// メインフォームでのInput管理を再開。

						Global.tダイアログ表示後始末();

						Global.Input.KeyAssign.t保存する( Global.Folder.strKeyAssignXMLの絶対パス );
					}
					//-----------------
					#endregion
					#region [ F12 → ユーザ管理ウィンドウ起動 ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F12 ) )
					{
						// 新しいユーザを選択する。

						string str選択されたユーザ名 = Global.Users.tユーザ管理ダイアログを表示し選択されたユーザ名を返す( Global.App.Window );

						if( !string.IsNullOrEmpty( str選択されたユーザ名 ) )
						{
							#region [ 新しいユーザが選択された。]
							//-----------------
							if( !str選択されたユーザ名.Equals( Global.Users.str現在のユーザ名, StringComparison.OrdinalIgnoreCase ) )
							{
								// 選択されたユーザが現在のユーザと異なる場合、古い選択ユーザ情報を破棄し、新しい選択ユーザの情報を読み込む。

								Global.App.tユーザのログアウト処理();
								Global.App.tユーザのログイン処理( str選択されたユーザ名 );

								// ユーザが変わったので、選曲ステージをリセットする。

								this.On非活性化();
								this.On活性化();
								this.t選択曲を最初の曲にリセットする();
								this.t現在の中心曲を起点として曲番号マップを更新する();
							}
							else
							{
								// 選択されたユーザが現在のユーザと同じである場合は、何もしない。
							}
							//-----------------
							#endregion
						}
						else
						{
							// 選択がキャンセルされた。
						}
					}
					//-----------------
					#endregion


					// 以下のキーは、曲が１曲以上ある場合のみ有効。

					if( this.list現在の曲リスト.Count > 0 )
					{
						#region [ Enter, シンバル類 → 曲決定 ]
						//-----------------
						if( Global.Input.Input管理.Keyboard.bキーが押された( Key.Return ) ||
							Global.Input.bシンバル類のいずれかが押された )
						{
							if( this.sd曲決定音 != null )
								this.sd曲決定音.tサウンドを先頭から再生する();

							if( this.ds背景動画 != null )
								this.ds背景動画.t再生停止();

							this.b曲決定 = true;
							return (int) E進行の戻り値.継続;	// ここではまだ終わらない。ds曲決定の再生が終わるまで待つ。
						}
						//-----------------
						#endregion
						#region [ 右矢印, FT → 曲マトリックスを右へスクロール ]
						//-----------------
						if( Global.Input.Input管理.Keyboard.bキーが押された( Key.RightArrow ) ||
							Global.Input.bフロアタム類のいずれかが押された )
						{
							// 最小でも-800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
							this.n目標のスクロールカウンタ = Math.Max( this.n目標のスクロールカウンタ - 100, -800 );
						}
						//-----------------
						#endregion
						#region [ 左矢印, SD → 曲マトリックスを左へスクロール ]
						//-----------------
						if( Global.Input.Input管理.Keyboard.bキーが押された( Key.LeftArrow ) ||
							Global.Input.bスネア類のいずれかが押された )
						{
							// 最大でも+800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
							this.n目標のスクロールカウンタ = Math.Min( this.n目標のスクロールカウンタ + 100, 800 );
						}
						//-----------------
						#endregion
						#region [ 上矢印, HT → 曲カーソルを上に移動。]
						//-----------------
						if( Global.Input.Input管理.Keyboard.bキーが押された( Key.UpArrow ) ||
							Global.Input.bハイタム類のいずれかが押された )
						{
							if( this.nカーソルY位置0to2 > 0 )
							{
								if( this.sdカーソル移動音 != null )
									this.sdカーソル移動音.tサウンドを先頭から再生する();

								this.nカーソルY位置0to2--;
								this.n現在の選択曲番号 = ( ( this.n現在の選択曲番号 - 1 ) + this.list現在の曲リスト.Count ) % this.list現在の曲リスト.Count;
							}
							else
							{
								this.nカーソルY位置0to2 = 2;

								// 最大でも+800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
								this.n目標のスクロールカウンタ = Math.Min( this.n目標のスクロールカウンタ + 100, 800 );
							}
						}
						//-----------------
						#endregion
						#region [ 下矢印, LT → 曲カーソルを下に移動。]
						//-----------------
						if( Global.Input.Input管理.Keyboard.bキーが押された( Key.DownArrow ) ||
							Global.Input.bロータム類のいずれかが押された )
						{
							if( this.nカーソルY位置0to2 < 2 )
							{
								if( this.sdカーソル移動音 != null )
									this.sdカーソル移動音.tサウンドを先頭から再生する();

								this.nカーソルY位置0to2++;
								this.n現在の選択曲番号 = ( this.n現在の選択曲番号 + 1 ) % this.list現在の曲リスト.Count;
							}
							else
							{
								this.nカーソルY位置0to2 = 0;

								// 最小でも-800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
								this.n目標のスクロールカウンタ = Math.Max( this.n目標のスクロールカウンタ - 100, -800 );
							}
						}
						//-----------------
						#endregion
					}
				}
			}

			return (int) E進行の戻り値.継続;
		}
		public override void On描画()
		{
			if( this.b活性化してない )
				return;

			Global.App.tデバイスをクリアする();

			#region [ 曲がないなら Song not found を表示して帰れ。]
			//-----------------
			if( this.list現在の曲リスト.Count == 0 )
			{
				#region [ 背景のブランク枠を表示。]
				//-----------------
				if( this.txブランク画像 != null )
				{
					for( int i = 0; i < 9 * 3; i++ )
					{
						int x = i / 3;
						int y = i % 3;
						var mat = Matrix.Identity;
						mat *= Matrix.Scaling( CTexture.f画面比率, CTexture.f画面比率, 1.0f );
						mat *= Matrix.RotationY( this.stマトリックス座標[ x, y ].rotY );
						mat *= Matrix.Translation(
							this.stマトリックス座標[ x, y ].x * CTexture.f画面比率,
							this.stマトリックス座標[ x, y ].y * CTexture.f画面比率,
							this.stマトリックス座標[ x, y ].z * CTexture.f画面比率 );
						this.txブランク画像.t3D描画( Global.App.D3D9Device, mat );
					}
				}
				//-----------------
				#endregion
				#region [ Song not found テクスチャを表示。]
				//-----------------
				if( this.txSongNotFound != null )
				{
					this.txSongNotFound.t2D描画( Global.App.D3D9Device,
						Global.Theme.LogicalDisplaySize.Width / 2 - this.txSongNotFound.sz画像サイズ.Width / 2,
						Global.Theme.LogicalDisplaySize.Height / 2 - this.txSongNotFound.sz画像サイズ.Height / 2 - 40 );	// -40 は背景に合わせた調整値。
				}
				//-----------------
				#endregion

				return;
			}
			//-----------------
			#endregion

			
			#region [ 背景動画を描画。]
			//-----------------
			if( this.ds背景動画 != null &&
				this.tx背景動画 != null )
			{
				#region [ ウィンドウサイズが変わってたら、拡大率を変更する。]
				//-----------------
				if( Global.Theme.LogicalDisplaySize.Width != this.ds背景動画.n幅px ||
					Global.Theme.LogicalDisplaySize.Height != this.ds背景動画.n高さpx )
				{
					this.tx背景動画.vc拡大縮小倍率 = new Vector3(
						( (float) Global.Theme.LogicalDisplaySize.Width / (float) this.ds背景動画.n幅px ),
						( (float) Global.Theme.LogicalDisplaySize.Height / (float) this.ds背景動画.n高さpx ),
						1.0f );
				}
				//-----------------
				#endregion

				this.ds背景動画.t現時点における最新のスナップイメージをTextureに転写する( this.tx背景動画 );
				this.tx背景動画.t2D描画( Global.App.D3D9Device, 0, 0 );
			}
			//-----------------
			#endregion

			#region [ カーソルを描画。]
			//-----------------
			if( this.txカーソル != null )
			{
				int cx = 4;	// 0～8 の中央
				int cy = this.nカーソルY位置0to2;

				var mat = Matrix.Identity;
				mat *= Matrix.Scaling( CTexture.f画面比率, CTexture.f画面比率, 1.0f );
				mat *= Matrix.RotationY( this.stマトリックス座標[ cx, cy ].rotY );
				mat *= Matrix.Translation(
					this.stマトリックス座標[ cx, cy ].x * CTexture.f画面比率,
					this.stマトリックス座標[ cx, cy ].y * CTexture.f画面比率,
					this.stマトリックス座標[ cx, cy ].z * CTexture.f画面比率 );
				this.txカーソル.t3D描画( Global.App.D3D9Device, mat );
			}
			//-----------------
			#endregion

			#region [ ar曲番号マップ[,] に従って曲マトリックスを描画する。]
			//-----------------
			for( int i = 0; i < 9 * 3; i++ )
			{
				int mx = i / 3;
				int my = i % 3;

				if( ( mx == 0 && this.n現在のスクロールカウンタ < 0 ) ||		// 最左列は、左に移動中なら表示しない。
					( mx == 8 && this.n現在のスクロールカウンタ > 0 ) )		// 最右列は、右に移動中なら表示しない。
					continue;

				var song = this.list現在の曲リスト[ this.ar曲番号マップ[ mx, my ] ];

				int dx = ( this.n現在のスクロールカウンタ == 0 ) ? 0 : ( ( this.n現在のスクロールカウンタ < 0 ) ? -1 : +1 );
				float f割合 = Math.Abs( this.n現在のスクロールカウンタ ) / 100.0f;

				#region [ サムネイルを描画。]
				//-----------------
				CTexture txTumbnail = null;

				#region [ サムネイルがないなら作成する。]
				//-----------------
				if( !this.dicThumbnail.ContainsKey( song.ScoreFile ) )
				{
					txTumbnail = this.tサムネイルテクスチャを作成する( Path.GetDirectoryName( song.ScoreFile ) );
					this.dicThumbnail.Add( song.ScoreFile, txTumbnail );
				}
				//-----------------
				#endregion

				txTumbnail = this.dicThumbnail[ song.ScoreFile ];
				if( txTumbnail != null )
				{
					var mat = Matrix.Identity;
					mat *= Matrix.Scaling( CTexture.f画面比率, CTexture.f画面比率, 1.0f );
					mat *= Matrix.RotationY( this.stマトリックス座標[ mx, my ].rotY + ( this.stマトリックス座標[ mx + dx, my ].rotY - this.stマトリックス座標[ mx, my ].rotY ) * f割合 );
					mat *= Matrix.Translation(
						( this.stマトリックス座標[ mx, my ].x + (int) ( ( this.stマトリックス座標[ mx + dx, my ].x - this.stマトリックス座標[ mx, my ].x ) * f割合 ) ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].y + (int) ( ( this.stマトリックス座標[ mx + dx, my ].y - this.stマトリックス座標[ mx, my ].y ) * f割合 ) ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].z + (int) ( ( this.stマトリックス座標[ mx + dx, my ].z - this.stマトリックス座標[ mx, my ].z ) * f割合 ) ) * CTexture.f画面比率 );
					txTumbnail.t3D描画( Global.App.D3D9Device, mat );
				}
				//-----------------
				#endregion
				#region [ プロパティを描画。]
				//-----------------
				CTexture txProperty = null;

				#region [ プロパティがないなら作成する。]
				//-----------------
				if( !this.dicProperty.ContainsKey( song.ScoreFile ) )
				{
					txProperty = this.tプロパティテクスチャを作成する( song.ScoreFile );
					this.dicProperty.Add( song.ScoreFile, txProperty );
				}
				//-----------------
				#endregion

				txProperty = this.dicProperty[ song.ScoreFile ];
				if( txProperty != null )
				{
					Matrix mat = Matrix.Identity;
					mat *= Matrix.Scaling( CTexture.f画面比率, CTexture.f画面比率, 1.0f );
					mat *= Matrix.RotationY( this.stマトリックス座標[ mx, my ].rotY + ( this.stマトリックス座標[ mx + dx, my ].rotY - this.stマトリックス座標[ mx, my ].rotY ) * f割合 );
					mat *= Matrix.Translation(
						( this.stマトリックス座標[ mx, my ].x + (int) ( ( this.stマトリックス座標[ mx + dx, my ].x - this.stマトリックス座標[ mx, my ].x ) * f割合 ) ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].y + (int) ( ( this.stマトリックス座標[ mx + dx, my ].y - this.stマトリックス座標[ mx, my ].y ) * f割合 )
							- Global.Theme.Thumbnail.Height / 2 - Global.Theme.ThumbnailProperty.Height / 2 - 4 ) * CTexture.f画面比率,	// -4 はマージン
						( this.stマトリックス座標[ mx, my ].z + (int) ( ( this.stマトリックス座標[ mx + dx, my ].z - this.stマトリックス座標[ mx, my ].z ) * f割合 ) ) * CTexture.f画面比率 );
					txProperty.t3D描画( Global.App.D3D9Device, mat );
				}
				//-----------------
				#endregion
			}
			//-----------------
			#endregion


			#region [ 超簡単な操作メモを下部に表示。]
			//-----------------
			Global.Act英数字.t表示( 16, Global.Theme.LogicalDisplaySize.Height - 32, CAct英数字.E種別.白,
				"F1:Settings, F2:SongList, F3:AssignDrums, F12:ChangeUser" );
			Global.Act英数字.t表示( 16, Global.Theme.LogicalDisplaySize.Height - 32 - 16, CAct英数字.E種別.白,
				"Cursor: MoveCursor, Enter:DecideSong, ESC:Exit" );
			//-----------------
			#endregion
		}

		#region [ protected ]
		//-----------------
		/// <summary>
		/// <para>現在選択中のSongが含まれるSongリスト。</para>
		/// <para>初期値はツリールート。BOXを出たり入ったりするたび更新される。</para>
		/// </summary>
		protected List<SongNode> list現在の曲リスト = null;
		
		/// <summary>
		/// <para>現在選択されているSong番号。</para>
		/// <para>この番号は、C選曲ステージ.list現在の曲リスト[] のインデックスを示す。</para>
		/// </summary>
		protected int n現在の選択曲番号
		{
			get
			{
				if( this.stackBOXの曲番号 == null ||
					this.stackBOXの曲番号.Count == 0 )
				{
					throw new InvalidOperationException( "stackBOXの曲番号 が null または中身が空です。" );
				}

				return this.stackBOXの曲番号.Peek();
			}
			set
			{
				if( this.stackBOXの曲番号 == null )
					throw new NullReferenceException( "stackBOXの曲番号 が null です。" );


				// 先頭要素を置換。

				if( this.stackBOXの曲番号.Count > 0 )	// 先頭要素があれば除去。
					this.stackBOXの曲番号.Pop();

				this.stackBOXの曲番号.Push( value );	// 新しい要素を格納。
			}
		}

		protected CSound sdカーソル移動音 = null;
		protected CSound sd曲決定音 = null;
		protected CDirectShow ds背景動画 = null;
		protected CTexture tx背景動画 = null;
		//-----------------
		#endregion

		#region [ private ]
		//-----------------
		private bool b曲決定;
		
		/// <summary>
		/// <para>BOXに入ったときの Global.Song.list曲リスト の曲番号（配列のインデックス）を階層的に記憶しておくための LIFO 。</para>
		/// <para>BOXに入るたびその BOX の曲番号を Push し、BOX から出るたび親 BOX の曲番号を Pop する。</para>
		/// <para>最初に Push されるのは、ツリールートの先頭曲番号(=0)。</para>
		/// <para>このスタックは基本的に C演奏ステージ.n現在の選択曲番号 プロパティで制御するため、private に置いておく。</para>
		/// </summary>
		private Stack<int> stackBOXの曲番号 = null;

		/// <summary>
		/// <para>3行7列（[7,3]）の曲番号の配列。</para>
		/// <para>△□□□□□△　　０が中心曲。（≠選択曲の場合あり）</para>
		/// <para>△□□□□□△　　■が選択曲。（≠中心曲の場合あり）</para>
		/// <para>△□□■□□△　　△は画面外。</para>
		/// </summary>
		private int[,] ar曲番号マップ = new int[ 9, 3 ];

		/// <summary>
		/// <para>曲リスト（マトリックス）表示のための基準点。</para>
		/// </summary>
		private int n現在の中心曲番号 = 0;
		
		/// <summary>
		/// <para>SSTFファイル絶対パス(key)とサムネイル画像(value)との辞書。</para>
		/// <para>アプリの起動から終了まで単純に増加を続け、要素が減ることはない。</para>
		/// </summary>
		private Dictionary<string, CTexture> dicThumbnail = new Dictionary<string, CTexture>();
		
		/// <summary>
		/// <para>SSTFファイル絶対パス(key)とプロパティ画像(value)との辞書。</para>
		/// <para>アプリの起動から終了まで単純に増加を続け、要素が減ることはない。</para>
		/// </summary>
		private Dictionary<string, CTexture> dicProperty = new Dictionary<string, CTexture>();

		private CTexture txブランク画像 = null;
		private CTexture txSongNotFound = null;
		private CTexture txカーソル = null;

		private int nカーソルY位置0to2;
		private int n現在のスクロールカウンタ;
		private int n目標のスクロールカウンタ;
		private C一定間隔処理 mスクロールアニメ用一定間隔処理;

		private struct ST中心点
		{
			public float x;
			public float y;
			public float z;
			public float rotY;
		}
		private readonly ST中心点[,] stマトリックス座標 = new ST中心点[ 9, 3 ] {
			#region [ 実は円弧配置になってない。射影行列間違ってるよスターレインボウ見せる気かよ… ]
			//-----------------
			{ new ST中心点() { x = -533.8936f, y = 210f, z = -289.5575f, rotY = -0.9279888f },
				new ST中心点() { x = -533.8936f, y = 50f, z = -289.5575f, rotY = -0.9279888f },
				new ST中心点() { x = -533.8936f, y = -110f, z = -289.5575f, rotY = -0.9279888f } },
			{ new ST中心点() { x = -423.8936f, y = 210f, z = -169.5575f, rotY = -0.6579891f },
				new ST中心点() { x = -423.8936f, y = 50f, z = -169.5575f, rotY = -0.6579891f },
				new ST中心点() { x = -423.8936f, y = -110f, z = -169.5575f, rotY = -0.6579891f } },
			{ new ST中心点() { x = -297.5025f, y = 210f, z = -74.37564f, rotY = -0.4808382f },
				new ST中心点() { x = -297.5025f, y = 50f, z = -74.37564f, rotY = -0.4808382f },
				new ST中心点() { x = -297.5025f, y = -110f, z = -74.37564f, rotY = -0.4808382f } },
			{ new ST中心点() { x = -153.9001f, y = 210f, z = -20.52002f, rotY = -0.2605f },
				new ST中心点() { x = -153.9001f, y = 50f, z = -20.52002f, rotY = -0.2605f },
				new ST中心点() { x = -153.9001f, y = -110f, z = -20.52002f, rotY = -0.2605f } },
			{ new ST中心点() { x = 0.00002622683f, y = 210f, z = 0f, rotY = 0f }, 
				new ST中心点() { x = 0.00002622683f, y = 50f, z = 0f, rotY = 0f }, 
				new ST中心点() { x = 0.00002622683f, y = -110f, z = 0f, rotY = 0f } },
			{ new ST中心点() { x = 153.9002f, y = 210f, z = -20.52002f, rotY = 0.2605f },
				new ST中心点() { x = 153.9002f, y = 50f, z = -20.52002f, rotY = 0.2605f },
				new ST中心点() { x = 153.9002f, y = -110f, z = -20.52002f, rotY = 0.2605f } },
			{ new ST中心点() { x = 297.5025f, y = 210f, z = -74.37564f, rotY = 0.4808382f },
				new ST中心点() { x = 297.5025f, y = 50f, z = -74.37564f, rotY = 0.4808382f },
				new ST中心点() { x = 297.5025f, y = -110f, z = -74.37564f, rotY = 0.4808382f } },
			{ new ST中心点() { x = 423.8936f, y = 210f, z = -169.5575f, rotY = 0.6579891f },
				new ST中心点() { x = 423.8936f, y = 50f, z = -169.5575f, rotY = 0.6579891f },
				new ST中心点() { x = 423.8936f, y = -110f, z = -169.5575f, rotY = 0.6579891f } },
			{ new ST中心点() { x = 533.8936f, y = 210f, z = -289.5575f, rotY = 0.9279888f },
				new ST中心点() { x = 533.8936f, y = 50f, z = -289.5575f, rotY = 0.9279888f },
				new ST中心点() { x = 533.8936f, y = -110f, z = -289.5575f, rotY = 0.9279888f } },
			//-----------------
			#endregion
		};

		private int t中心曲から指定された相対数だけ離れた曲番号を返す( int n相対数 )
		{
			int n曲番号 = this.n現在の中心曲番号 + n相対数;
			int n曲数 = this.list現在の曲リスト.Count;

			// リストは、正方向にも負方向にも循環する。

			while( n曲番号 < 0 )	
				n曲番号 += n曲数;

			return n曲番号 % n曲数;
		}
		private void t現在の中心曲を起点として曲番号マップを更新する()
		{
			// マップをクリア。

			for( int i = 0; i < 9 * 3; i++ )
				this.ar曲番号マップ[ ( i % 9 ), ( i / 9 ) ] = 0;


			// 曲がないならここで終わり。

			if( this.list現在の曲リスト.Count == 0 )
				return;


			// 中心曲番号を起点にマップを生成する。

			// △□□□□□□□△		-13 -10 -7 -4 -1 ２ ５ ８ 11	０が中心曲。（≠選択曲の場合あり）
			// △□□□□□□□△	→	-12  -9 -6 -3 ０ ３ ６ ９ 12	■が選択曲。（≠中心曲の場合あり）
			// △□□□■□□□△		-11  -8 -5 -2 １ ４ ７ 10 13	△は画面外。

			for( int i = 0; i < 9 * 3; i++ )
				this.ar曲番号マップ[ ( i / 3 ), ( i % 3 ) ] = this.t中心曲から指定された相対数だけ離れた曲番号を返す( i - 13 );
		}
		private CTexture tサムネイルテクスチャを作成する( string strフォルダパス )
		{
			string[] files = Directory.GetFiles( strフォルダパス, "thumb.*" );
			foreach( var file in files )
			{
				string ext = Path.GetExtension( file ).ToLower();

				if( ext.Equals( ".jpg" ) || ext.Equals( ".jpeg" ) ||	// 片っ端から放り込んでログが例外の山になるものウザイし、
					ext.Equals( ".png" ) ||								// とりあえず対応拡張子はこれだけにしておく。
					ext.Equals( ".bmp" ) )
				{
					using( var bmpOriginal = new Bitmap( file ) )
					using( var bmp = new Bitmap( Global.Theme.Thumbnail.Width, Global.Theme.Thumbnail.Height ) )
					using( var g = Graphics.FromImage( bmp ) )
					{
						g.FillRectangle( Brushes.Black, 0, 0, bmp.Width, bmp.Height );

						// bmpOriginal を、bmp 内部に収まり、センタリングされる位置に描画する。
						// 小さい画像は拡大し、大きい画像は縮小する。

						int w = bmpOriginal.Width;
						int h = bmpOriginal.Height;

						if( w > h )
						{
							h = (int) ( h * (double) bmp.Width / (double) w );
							w = bmp.Width;
						}
						else
						{
							w = (int) ( w * (double) bmp.Height / (double) h );
							h = bmp.Height;
						}
						int x = ( bmp.Width - w ) / 2;
						int y = ( bmp.Height - h ) / 2;

						g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.Bicubic;
						g.DrawImage( bmpOriginal, new Rectangle( x, y, w, h ) );


						// 画像を白で縁取る。

						const int n幅 = 8;	//pixel
						g.FillRectangle( Brushes.White, new Rectangle( 0, 0, n幅, bmp.Height ) );
						g.FillRectangle( Brushes.White, new Rectangle( bmp.Width - n幅, 0, n幅, bmp.Height ) );
						g.FillRectangle( Brushes.White, new Rectangle( 0, 0, bmp.Width, n幅 ) );
						g.FillRectangle( Brushes.White, new Rectangle( 0, bmp.Height - n幅, bmp.Width, bmp.Height ) );


						// 以上の bmp からテクスチャを作成。

						return Global.tテクスチャを生成する( bmp );
					}
				}
			}

			return Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect no image.png" ) );
		}
		private CTexture tプロパティテクスチャを作成する( string str曲ファイルパス )
		{
			// スコアのヘッダを読み込む。

			var score = new Cスコア();
			try
			{
				score.t曲データファイルを読み込む・ヘッダだけ( str曲ファイルパス );
			}
			catch
			{
				#region [ 読み込み失敗 → 空のテクスチャを返す。]
				//-----------------
				CTexture txBlank = null;
				using( var bmp = new Bitmap( Global.Theme.ThumbnailProperty.Width, Global.Theme.ThumbnailProperty.Height ) )
				{
					txBlank = Global.tテクスチャを生成する( bmp );
				}
				return txBlank;
				//-----------------
				#endregion
			}


			// プロパティテクスチャを作成。

			CTexture txProperty = null;

			using( var bmp = new Bitmap( Global.Theme.ThumbnailProperty.Width, Global.Theme.ThumbnailProperty.Height ) )
			using( var g = Graphics.FromImage( bmp ) )
			using( var font = new Font( FontFamily.GenericSerif, 12.0f ) )
			using( var format = new StringFormat() { Alignment = StringAlignment.Center } )
			{
				var rc = new RectangleF( 0f, 0f, (float) bmp.Width, (float) bmp.Height );

				g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
				g.DrawString( string.Format( "{0}", score.Header.str曲名 ), font, Brushes.White, rc, format );

				txProperty = Global.tテクスチャを生成する( bmp );
			}

			return txProperty;
		}
		//-----------------
		#endregion
	}
}

